/***************************************************************************
                          contactlisttooltip.cpp  -  description
                             -------------------
    begin                : Mon Sep 8 2003
    copyright            : (C) 2003 by Michael Curtis
    email                : michael@kmess.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "contactlisttooltip.h"

#include <qtooltip.h>

#include <kdebug.h>

#include "contact.h"
#include "contactlist.h"
#include "contactlistview.h"
#include "contactlistviewitem.h"

// The constructor
ContactListToolTip::ContactListToolTip( ContactListView * widget, ContactList *contactList,  QToolTipGroup * group )
 : QToolTip( widget->viewport(), group )
{
  listView_ = widget;
  contactList_ = contactList;
}



// The destructor
ContactListToolTip::~ContactListToolTip()
{
}


// Decide whether we want to tip
void ContactListToolTip::maybeTip( const QPoint & p )
{
  ContactListViewItem *listItem = (ContactListViewItem*) listView_->itemAt( p );
  Contact * contact;

  if ( listItem != 0 )
  {
     contact = contactList_->getContactByItem( (QListViewItem *) listItem );

     if ( contact != 0 )
     {
       tip( listView_->itemRect( listItem ), contact->getHandle() + "\n" + contact->getTrueFriendlyName() );
     }
  }
}

