/***************************************************************************
                          contactnamedialog.h  -  description
                             -------------------
    begin                : Mon Nov 11 2002
    copyright            : (C) 2002 by Mike K. Bennett
    email                : mkb137b@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONTACTNAMEDIALOG_H
#define CONTACTNAMEDIALOG_H

#include <kdialogbase.h>

// Forward declarations
class KLineEdit;

/**A dialog for obtaining the user's preferred nickname for a contact.
  *@author Mike K. Bennett
  */

class ContactNameDialog : public KDialogBase
{
   Q_OBJECT

  public:
    // The contstructor
  	             ContactNameDialog(QWidget *parent=0, const char *name=0);
    // The constructor
  	            ~ContactNameDialog();
    // Show the dialog and, if OK is pressed, change the group name to what
    //  the user has selected.
    bool         launch(QString &contactName);

  protected slots: // Protected slots
    // The Cancel button was pressed.
    void         slotCancel();
    // The OK button was pressed.
    void         slotOk();

  private: // Private attributes
    // The contact name edit
    KLineEdit   *friendlyNameEdit_;
    // Whether or not OK was pressed.
    bool         ok_;
};

#endif
