/***************************************************************************
                          groupnamedialog.h  -  description
                             -------------------
    begin                : Sun Apr 14 2002
    copyright            : (C) 2002 by Mike K. Bennett
    email                : mkb137b@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GROUPNAMEDIALOG_H
#define GROUPNAMEDIALOG_H

#include <qcstring.h>
#include <qwidget.h>
#include <kdialogbase.h>

// Forward declarations
class KLineEdit;

/**This dialog allows the user to select a group name.
  *@author Mike K. Bennett
  */

class GroupNameDialog : public KDialogBase
{
   Q_OBJECT

  public:
  	             GroupNameDialog(QWidget *parent=0, const char *name=0);
  	            ~GroupNameDialog();
    // Show the dialog and, if OK is pressed, change the group name to what
    //  the user has selected.
    bool         launch(QString &groupName);

  protected slots: // Protected slots
    // The Cancel button was pressed.
    void         slotCancel();
    // The OK button was pressed.
    void         slotOk();

  private: // Private attributes
    // The group name edit
    KLineEdit   *nameEdit_;
    // Whether or not OK was pressed.
    bool         ok_;
};

#endif
