
/***************************************************************************
                          emoticoncollection.cpp  -  description
                             -------------------
    begin                : Mon Apr 15 2002
    copyright            : (C) 2003 by Michael Curtis
    email                : mdcurtis@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 **************************************************************************/

#include "emoticoncollection.h"

#include <qcolor.h>
#include <qptrlist.h>
#include <qregexp.h>

#include <kdebug.h>

#include "emoticon.h"

// Initialize the instance to zero
EmoticonCollection* EmoticonCollection::instance_(0);


// The constructor
EmoticonCollection::EmoticonCollection()
 : QPtrList<Emoticon>()
{
  Emoticon *emoticon;

  clear();

  // MSN6 Smiley definitions added by Mokoshi

  // put some emoticons in our collection
  emoticon = new Emoticon( ":\\)",     "regular" );
  emoticon->addText( ":-\\)" );
  append( emoticon );

  emoticon = new Emoticon( ";\\)",     "wink" );
  emoticon->addText( ";-\\)" );
  append( emoticon );

  emoticon = new Emoticon( ":P",        "tongue" );
  emoticon->addText( ":p"  );
  emoticon->addText( ":-P" );
  emoticon->addText( ":-p" );
  append( emoticon );

  emoticon = new Emoticon( ":D",        "teeth" );
  emoticon->addText( ":d"      );
  emoticon->addText( ":-D"     );
  emoticon->addText( ":-d"     );
  emoticon->addText( ":>"      );
  emoticon->addText( ":->"     );
  emoticon->addText( ":&gt;"   );
  emoticon->addText( ":-&gt;"  );
  append( emoticon );

  emoticon = new Emoticon( ":\\(",     "sad" );
  emoticon->addText( ":-\\("   );
  emoticon->addText( ":<"     );
  emoticon->addText( ":-<"    );
  emoticon->addText( ":&lt;"  );
  emoticon->addText( ":-&lt;" );
  append( emoticon );

  append( new Emoticon( ":'\\(",     "cry" ) );


  emoticon = new Emoticon( ":@",       "angry" );
  emoticon->addText( ":-@" );
  append( emoticon );

  emoticon = new Emoticon( ":S",        "confused" );
  emoticon->addText( ":s"  );
  emoticon->addText( ":-S" );
  emoticon->addText( ":-s" );
  append( emoticon );

  emoticon = new Emoticon( ":\\$",     "embarrassed" );
  emoticon->addText( ":-\\$" );
  append( emoticon );

  emoticon = new Emoticon( ":\\|",     "ugly" );
  emoticon->addText( ":-\\|" );
  append( emoticon );

  emoticon = new Emoticon( "\\(H\\)",   "shade" );
  emoticon->addText( "\\(h\\)" );
  append( emoticon );


  append( new Emoticon( "8o\\|", "bearingteeth" ) );

  append( new Emoticon( "8-\\|", "nerd" ) );

  append( new Emoticon( "\\+o\\(", "sick" ) );

  emoticon = new Emoticon( ":O",        "omg" );
  emoticon->addText( ":o"  );
  emoticon->addText( ":-O" );
  emoticon->addText( ":-o" );
  append( emoticon );

  emoticon = new Emoticon( "<:o\\)",   "party" );
  emoticon->addText( "&lt;:o\\)" );
  append( emoticon );

  append( new Emoticon( "\\|-\\)", "sleepy" ) );

  append( new Emoticon( "\\*-\\)", "thinking" ) );


  append( new Emoticon( ":-\\#", "sshh" ) );

  append( new Emoticon( ":-\\*", "secret" ) );

  append( new Emoticon( "8-\\)", "eyeroll" ) );

  append( new Emoticon( "\\^o\\)", "sarcastic" ) );

  append( new Emoticon( ":\\^\\)", "huh" ) );

  append( new Emoticon( "\\|-\\)", "uh" ) );


  emoticon = new Emoticon( "\\(A\\)",   "angel" );
  emoticon->addText( "\\(a\\)" );
  append( emoticon );

  append( new Emoticon( "\\(6\\)",   "devil" ) );

  emoticon = new Emoticon( "\\(K\\)",   "kiss" );
  emoticon->addText( "\\(k\\)" );
  append( emoticon );

  append( new Emoticon( "\\(brb\\)", "brb" ) );

  append( new Emoticon( "\\(au\\)", "au" ) );

  append( new Emoticon( "\\(ap\\)", "ap" ) );


  append( new Emoticon( "\\(\\{\\)", "dude_hug" ) );

  emoticon = new Emoticon( "\\(Z\\)",   "boy" );
  emoticon->addText( "\\(z\\)" );
  append( emoticon );

  emoticon = new Emoticon( "\\(L\\)",   "love" );
  emoticon->addText( "\\(l\\)" );
  append( emoticon );

  emoticon = new Emoticon( "\\(F\\)",   "rose" );
  emoticon->addText( "\\(f\\)" );
  append( emoticon );

  emoticon = new Emoticon( "\\(Y\\)",   "thumbs_up" );
  emoticon->addText( "\\(y\\)" );
  append( emoticon );

  append( new Emoticon( "\\(yn\\)", "yn" ) );


  append( new Emoticon( "\\(\\}\\)", "girl_hug" ) );

  emoticon = new Emoticon( "\\(X\\)",   "girl" );
  emoticon->addText( "\\(x\\)" );
  append( emoticon );

  emoticon = new Emoticon( "\\(U\\)",   "unlove" );
  emoticon->addText( "\\(u\\)" );
  append( emoticon );

  emoticon = new Emoticon( "\\(W\\)",   "wilted_rose" );
  emoticon->addText( "\\(w\\)" );
  append( emoticon );

  emoticon = new Emoticon( "\\(N\\)",   "thumbs_down" );
  emoticon->addText( "\\(n\\)" );
  append( emoticon );

  append( new Emoticon( "\\(h5\\)", "h5" ) );


  append( new Emoticon( "\\(&\\)", "dog" ) );

  append( new Emoticon( "\\(@\\)", "cat" ) );

  append( new Emoticon( "\\(tu\\)", "tu" ) );

  append( new Emoticon( "\\(sn\\)", "snail" ) );

  append( new Emoticon( "\\(bah\\)", "sheep" ) );

  emoticon = new Emoticon( ":\\[",     "bat" );
  emoticon->addText( ":-\\[" );
  append( emoticon );


  emoticon = new Emoticon( "\\(B\\)",   "beer" );
  emoticon->addText( "\\(b\\)" );
  append( emoticon );

  emoticon = new Emoticon( "\\(D\\)",   "cocktail" );
  emoticon->addText( "\\(d\\)" );
  append( emoticon );

  emoticon = new Emoticon( "\\(C\\)",   "cup" );
  emoticon->addText( "\\(c\\)" );
  append( emoticon );

  append( new Emoticon( "\\(\\^\\)", "cake" ) );

  append( new Emoticon( "\\(pl\\)", "pl" ) );

  append( new Emoticon( "\\(pi\\)", "pizza" ) );


  append( new Emoticon( "\\(\\*\\)", "star" ) );

  append( new Emoticon( "\\(S\\)", "moon" ) );

  emoticon = new Emoticon( "\\(R\\)",   "rainbow" );
  emoticon->addText( "\\(r\\)" );
  append( emoticon );

  append( new Emoticon( "\\(\\#\\)", "sun" ) );

  append( new Emoticon( "\\(st\\)", "st" ) );

  append( new Emoticon( "\\(li\\)", "li" ) );


  append( new Emoticon( "\\(um\\)", "um" ) );

  append( new Emoticon( "\\(ip\\)", "ip" ) );

  emoticon = new Emoticon( "\\(T\\)",   "phone" );
  emoticon->addText( "\\(t\\)" );
  append( emoticon );

  append( new Emoticon( "\\(mp\\)", "mp" ) );

  append( new Emoticon( "\\(E\\)", "envelope" ) );

  emoticon = new Emoticon( "\\(O\\)",   "clock" );
  emoticon->addText( "\\(o\\)" );
  append( emoticon );


  emoticon = new Emoticon( "\\(P\\)",   "camera" );
  emoticon->addText( "\\(p\\)" );
  append( emoticon );

  append( new Emoticon( "\\(\\~\\)",   "film" ) );

  append( new Emoticon( "\\(8\\)",   "note" ) );

  append( new Emoticon( "\\(\\%\\)", "handcuffs" ) );

  append( new Emoticon( "\\(mo\\)", "mo" ) );

  emoticon = new Emoticon( "\\(I\\)",   "lightbulb" );
  emoticon->addText( "\\(i\\)" );
  append( emoticon );


  append( new Emoticon( "\\(\\|\\|\\)", "ll" ) );

  append( new Emoticon( "\\(ci\\)", "ci" ) );

  append( new Emoticon( "\\(so\\)", "so" ) );

  emoticon = new Emoticon( "\\(G\\)",   "present" );
  emoticon->addText( "\\(g\\)" );
  append( emoticon );

  append( new Emoticon( "\\(xx\\)", "xx" ) );

  append( new Emoticon( "\\(co\\)", "co" ) );


  append( new Emoticon( "\\(\\?\\)",   "asl" ) );

  emoticon = new Emoticon( "\\(M\\)",   "messenger" );
  emoticon->addText( "\\(m\\)" );
  append( emoticon );
}



// The destructor
EmoticonCollection::~EmoticonCollection()
{
}



// Delete the instance of the emoticon collection
void EmoticonCollection::destroy()
{
  delete instance_;
  instance_ = 0;
}


// Return a singleton instance of the emoticon collection
EmoticonCollection* EmoticonCollection::instance()
{
  // If the instance is null, create a new emoticon collection and return that.
  if ( instance_ == 0 )
  {
    instance_ = new EmoticonCollection();
  }
  return instance_;
}



// Replace the emoticons in the text with the urls to the emoticon pngs.
void EmoticonCollection::parseEmoticons( QString &text, bool small )
{
  Emoticon *emoticon;

  // parse the emoticons in reverse order, as they get more complicated as they
  //  go along, therefore this avoids complicated emoticons clashing with
  //  simple ones
  for ( emoticon = last(); emoticon; emoticon = prev() )
  {
    if ( emoticon->isValid() )
    {
      text = text.replace( QRegExp( emoticon->getPattern() ),
                           emoticon->getHtml( small ) );
    }
  }
}


