/***************************************************************************
                          kmesstest.cpp  -  description
                             -------------------
    begin                : Sun Jan 5 2003
    copyright            : (C) 2003 by Mike K. Bennett
    email                : mkb137b@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kmesstest.h"

#include <math.h>
#include <stdlib.h>

#include <qlistview.h>
#include <qregexp.h>

#include <kdebug.h>

#include "settings/settingsdialog.h"
#include "network/msnnotificationconnection.h"
#include "network/msnswitchboardconnection.h"
#include "notification/contactonlinenotification.h"
#include "contact/contact.h"
#include "contact/contactlist.h"
#include "contact/group.h"
#include "currentaccount.h"
#include "kmess.h"
#include "kmessview.h"

// The constructor
KMessTest::KMessTest(KMess *kmess)
 : kmess_(kmess)
{
}



// The destructor
KMessTest::~KMessTest()
{
  kdDebug() << "KMessTest DESTROYED" << endl;
}



// The main testing function
void KMessTest::test()
{
  kdDebug() << "----------------------------------------" << endl << endl;
//  testNotificationConnection();
//  testContactListWithNotificationConnection();
//  testConnect();
//  testSettings();
//  testSwitchboardConnection();
//  testNotifications();
//  testIsoName();
  testSizeControls();
  kdDebug()  << endl << "----------------------------------------" << endl;
}



int KMessTest::charToInt(char c)
{
  int i;
  i = (int)c;
  if ( i < 0 )
  {
    i += 256;
  }
  return i;
}



char KMessTest::intToChar(int i)
{
  return (char)i;
}



void KMessTest::testSizeControls()
{
/*
  int  i0, i1, i2, size;
  char c0, c1, c2;
//  size = 2048;
  size = 1576;
  i0 = 0;
  i1 = (size - 3)%256;
  i2 = (size - 3)/256;
  kdDebug() << "Before: i0 = '" << i0 << "' i1 = '" << i1 << "' i2 = '" << i2 << "'." << endl;

  c0 = (char)i0;
  c1 = (char)i1;
  c2 = (char)i2;

  i0 = (int)c0;
  i1 = (int)c1;
  i2 = (int)c2;
  size = i1 + 256 * i2;
  kdDebug() << "Before: size = " << size << ", c0 = '" << c0 << "' c1 = '" << c1 << "' c2 = '" << c2 << "'." << endl;
  kdDebug() << "After:  size = " << size << ", i0 = '" << i0 << "' i1 = '" << i1 << "' i2 = '" << i2 << "'." << endl;
*/
  int i1, i2;
  char c1;

  i1 = 253;
  c1 = intToChar(i1);
  i2 = charToInt(c1);
  kdDebug() << "i1 = " << i1 << " c1 = " << c1 << " i2 = " << i2 << endl;

  i1 = 37;
  c1 = intToChar(i1);
  i2 = charToInt(c1);
  kdDebug() << "i1 = " << i1 << " c1 = " << c1 << " i2 = " << i2 << endl;

  i1 = 128;
  c1 = intToChar(i1);
  i2 = charToInt(c1);
  kdDebug() << "i1 = " << i1 << " c1 = " << c1 << " i2 = " << i2 << endl;

  i1 = 127;
  c1 = intToChar(i1);
  i2 = charToInt(c1);
  kdDebug() << "i1 = " << i1 << " c1 = " << c1 << " i2 = " << i2 << endl;

  i1 = 240;
  c1 = intToChar(i1);
  i2 = charToInt(c1);
  kdDebug() << "i1 = " << i1 << " c1 = " << c1 << " i2 = " << i2 << endl;

  i1 = 10;
  c1 = intToChar(i1);
  i2 = charToInt(c1);
  kdDebug() << "i1 = " << i1 << " c1 = " << c1 << " i2 = " << i2 << endl;

  for ( int i = 0; i < 256; i++ )
  {
    c1 = intToChar( i );
    i2 = charToInt( c1 );
    ASSERT( i == i2 );
  }
/*
  i1 = 253;
  c1 = itoa(i1);
  i2 = atoi(c1);
  kdDebug() << "i1 = " << i1 << " c1 = " << c1 << " i2 = " << i2 << endl;
*/

}



// Remove the iso-designating characters from some text
void KMessTest::removeIsoChars(QString &text)
{
  int      start, middle, littleQ, bigQ, end;
  QString newText;
  while ( text.contains("=\?") )
  {
    start = text.find("=?");
    // It seems to use either "Q" or "q"
    littleQ = text.find("?q?");
    bigQ = text.find("?Q?");

    kdDebug() << "?q? is at " << littleQ << ", ?Q? is at " << bigQ << "." << endl;
    if ( ( littleQ >= 0 ) && ( bigQ >= 0 ) )
    {
      // If both were found, get the smallest
      if ( littleQ < bigQ )
      {
        middle = littleQ;
      }
      else
      {
        middle = bigQ;
      }
    }
    else if ( littleQ >= 0 )
    {
      // If only ?q? was found...
      middle = littleQ;
    }
    else if ( bigQ >= 0 )
    {
      // If only ?Q? was found..
      middle = bigQ;
    }
    else
    {
      kdDebug() << "removeIsoChars - No ?q? or ?Q? found in " << text << "." << endl;
      break;
    }
    end = text.find("?=");
    kdDebug() << "Start = " << start << " Middle = " << middle << " End = " << end << " (length is " << text.length()  << ")." << endl;
    kdDebug() << "Text is '" << text.left(start) << "' + '" << text.mid( middle + 3, end - middle - 3 ) << "' + '" << text.right( text.length() - end - 2 ) << "'." << endl;
    newText = text.left(start) + text.mid( middle + 3, end - middle - 3 ) + text.right( text.length() - end - 2 );
    // If there were any "?"s in the text, they were replaced with "=3f"s.
    newText = newText.replace( QRegExp("=3F"), "?" );
    // Replace underscores with spaces
    newText = newText.replace( QRegExp("_"), " " );
    // I'm anticipating that underscores will have been replaced by =5f
    newText = newText.replace( QRegExp("=5F"), "_" );

    text = newText;
  }
}



void KMessTest::testIsoName()
{
  QString text ;

  text = "Jan =?iso-8859-1?q?T=F6njes?=";
  kdDebug() << "Remove iso from '" << text << "'." << endl;
  removeIsoChars( text );
  kdDebug() << "Text is now '" << text << "'." << endl;

  text = "=?iso-8859-1?q?Jan?= =?iso-8859-1?q?T=F6njes?=";
  kdDebug() << "Remove iso from '" << text << "'." << endl;
  removeIsoChars( text );
  kdDebug() << "Text is now '" << text << "'." << endl;

  text = "=?windows-1250?Q?liste_de_prix_du_05_FEVRIER_2003?=";
  kdDebug() << "Remove iso from '" << text << "'." << endl;
  removeIsoChars( text );
  kdDebug() << "Text is now '" << text << "'." << endl;

  text = "=?iso-8859-1?Q?Re:_Fwd:_Do_you_take_feature_requests=3F?=";
  kdDebug() << "Remove iso from '" << text << "'." << endl;
  removeIsoChars( text );
  kdDebug() << "Text is now '" << text << "'." << endl;
}



void KMessTest::testNotifications()
{
  /*ContactOnlineNotification *cn = new ContactOnlineNotification( kmess_->systemTrayWidget_, this, "cn" );
  Contact *contact = kmess_->msnNotificationConnection_->contactList_->getContactByHandle( "mkb137b@hotmail.com" );
  if ( contact != 0 )
  {
    cn->contactOnline( contact );
  }*/
}



void KMessTest::testNotificationConnection()
{
}



void KMessTest::testContactListWithNotificationConnection()
{
}



void KMessTest::testConnect()
{
}


void KMessTest::testSettings()
{
}



void KMessTest::testSwitchboardConnection()
{
}
