/***************************************************************************
                          kmessview.h  -  description
                             -------------------
    begin                : Thu Jan 9 2003
    copyright            : (C) 2003 by Mike K. Bennett
    email                : mkb137b@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMESSVIEW_H
#define KMESSVIEW_H

#include <qwidget.h>
#include "kmessviewinterface.h"

// Forward declarations
class CurrentAccount;

/**The main view widget containing the contact list QListView and user status and email displays.
  *@author Mike K. Bennett
  */

class KMessView : public KMessViewInterface
{
  Q_OBJECT

  public:
    // The constructor
  	                 KMessView(QWidget *parent=0, const char *name=0);
    // The destructor
  	                ~KMessView();
    // The program is connected to the server.  Store the user account and
    //  update the user information.
    void             connected();
    // Called when the program has disconnected from the server.
    void             disconnected();
    // Initialize the class
    bool             initialize();

  private: // Private methods
    // Initialize the contact list view
    bool             initContactListView();

  private slots: // Private slots
    // The email label was clicked so open the user's preferred email url
    void             emailLabelClicked();
    // Change whether or not the email label is displayed based on account settings.
    void             updateEmailDisplay();
    // Update the email count.
    void             updateNoEmails();
    // Update the user's status.
    void             updateUserStatus();

  private: // Private attributes
    // A pointer to the instance of the current account
    CurrentAccount  *currentAccount_;
    // Whether or not the object has been initialized
    bool             initialized_;
};

#endif
