/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Sun Jan  5 15:18:36 CST 2003
    copyright            : (C) 2003 by Mike K. Bennett
    email                : mkb137b@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <kdebug.h>
#include <klocale.h>

#include "kmess.h"
#include "kmessdebug.h"
#include "kmesstest.h"

static const char *description =
	I18N_NOOP("KMess");
// INSERT A DESCRIPTION FOR YOUR APPLICATION HERE
	
	
static KCmdLineOptions options[] =
{
  { "autologin ", I18N_NOOP("Autologin with the given email address"), 0 },
  { 0, 0, 0 }
  // INSERT YOUR COMMANDLINE OPTIONS HERE
};

int main(int argc, char *argv[])
{
  KAboutData aboutData( "kmess", I18N_NOOP("KMess"),
    VERSION, description, KAboutData::License_GPL,
    "(c) 2002, Mike K. Bennett\n\nkmess.sourceforge.net", 0, 0, "mkb137b@hotmail.com");
  aboutData.addAuthor("Mike K. Bennett", 0, "mkb137b@hotmail.com");
  aboutData.addAuthor("Michael Curtis", 0, "mdcurtis@users.sourceforge.net");
  aboutData.addAuthor("Jan Tönjes", 0,"jan.toenjes@web.de");
  aboutData.addAuthor("Lin Haoxiang",0,"linhaoxiang@hotmail.com");
  aboutData.addCredit("Jan Tönjes",I18N_NOOP("German translation, testing, documentation, web master, project management, etc"),"jan.toenjes@web.de");
  aboutData.addCredit("Dane Harnett", I18N_NOOP("Web design"), "dynamitedane@hotmail.com");
  aboutData.addCredit("Johanna Gersch",I18N_NOOP("Spanish translation"));
  aboutData.addCredit("Gorkem Cetin",I18N_NOOP("Turkish translation"),"gorkem@gelecek.com.tr");
  aboutData.addCredit("Mauricio Rother",I18N_NOOP("Brazilian Portuguese translation"),"mauricio@digicomm.com.br");
  aboutData.addCredit("David Vignoni",I18N_NOOP("The main and yellow/blue/violet emoticon sets and Italian translation"),"dvgn@libero.it");
  aboutData.addCredit("Laurence Anderson",I18N_NOOP("Original file receive code"),"l.d.anderson@warwick.ac.uk");
  aboutData.addCredit("J.C.A. Javi",I18N_NOOP("more Spanish translation"),"yovoya30ks@hotmail.com");
  aboutData.addCredit("Arend van Beelen Jr.",I18N_NOOP("Dutch translation"),"arend@auton.nl");
  aboutData.addCredit("Scott Morgan",I18N_NOOP("Xinerama fixes"),"blumf@blumf.freeserve.co.uk");
  aboutData.addCredit("Julien Joubin",I18N_NOOP("Cartoon emoticons"),"jujubinche@netscape.net");
  aboutData.addCredit("Christian Muller",I18N_NOOP("Default sound theme"),"cmue81@gmx.de");
  aboutData.addCredit("Mohamed Aser",I18N_NOOP("Arabic translation, internationalization of file saving fix."),"mohasr@link.net");
  aboutData.addCredit("Choe Hwanjin",I18N_NOOP("Various internationalization fixes."),"hjchoe@hancom.com");
  aboutData.addCredit("Choplair",I18N_NOOP("French translation"),"pachilor@yahoo.co.jp");
  aboutData.addCredit("Vincent Fretin", I18N_NOOP("More French translation, MSN6 emoticon definitions"),"fretinvincent@hotmail.com");
  aboutData.addCredit("Park Dong Cheon",I18N_NOOP("Korean translation"),"pdc@kaist.ac.kr");
  aboutData.addCredit("Øyvind Sæther",I18N_NOOP("Norsk Bokmal tranlation"),"oyvind@sather.tk");
  aboutData.addCredit("Rachan Hongpairote",I18N_NOOP("Thai tranlation"),"rachanh@yahoo.com");
  aboutData.addCredit("Lin Haoxiang",I18N_NOOP("Simplified Chinese tranlation, file send bug fix"),"linhaoxiang@hotmail.com");
  aboutData.addCredit("Jaume Cornad",I18N_NOOP("Catalan tranlation"),"jaumec@lleida.net");
  aboutData.addCredit("Barbaros Ulutas",I18N_NOOP("More Turkish translation"),"tebarul@yahoo.com");
  aboutData.addCredit("Tobias Tönjes",I18N_NOOP("Guy with a bag over his head"),"");
  aboutData.addCredit("Damien Sandras",I18N_NOOP("GnomeMeeting developer"),"dsandras@seconix.com");
  aboutData.addCredit("Lars Sommer",I18N_NOOP("Danish tranlation"),"admin@lasg.dk");
  aboutData.addCredit("Jyri Toomessoo",I18N_NOOP("Estonian tranlation"),"nuubik@hotmail.com");
  aboutData.addCredit("KMerlin (kmerlin.olsd.de)",I18N_NOOP("Inspiration and assorted code"));
  aboutData.addCredit("Kopete (kopete.kde.org)", I18N_NOOP("Popup Balloon code"));
  aboutData.addCredit("KScreensaver",I18N_NOOP("Idle timer code"));
  aboutData.setTranslator(I18N_NOOP("_: NAME OF TRANSLATORS\nYour names"),I18N_NOOP("_: EMAIL OF TRANSLATORS\nYour emails"));

  KCmdLineArgs::init( argc, argv, &aboutData );
  KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

  KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
  QString autologinHandle = args->getOption("autologin");

  KApplication a;
  KMess *kmess = new KMess();
  if ( kmess->initialize() )
  {
    a.setMainWidget(kmess);
    kmess->show();
    kmess->checkAutologin( autologinHandle );
/*  
#ifdef KMESSTEST
    KMessTest *kmessTest = new KMessTest(kmess);
    kmessTest->test();
    delete kmessTest;
#endif
*/
  }
  return a.exec();
}
