/***************************************************************************
                          msnobject.cpp  -  description
                             -------------------
    begin                : Tue Jul 15 2003
    copyright            : (C) 2003 by Mike K. Bennett
    email                : mike@kmess.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "msnobject.h"

#include <qregexp.h>

#include <kdebug.h>

// The constructor
MsnObject::MsnObject()
 : size_(0)
{
}



// The destructor
MsnObject::~MsnObject()
{
}



// Parse an attribute from the object string
QString MsnObject::getAttribute( const QString& name, const QString& object ) const
{
  QString value;
  int     index;
  // Find the value in the object string
  index = object.find( name, 0 );
  if ( index >= 0 )
  {
    // Go past the name and the ="
    index = index + name.length() + 2;
    value = object.right( object.length() - index );
    // Find the next "
    index = value.find( QRegExp( "\"" ), 0 );
    value = value.left( index );
  }
  return value;
}



// Get the object's creator
const QString& MsnObject::getCreator() const
{
  return creator_;
}



// Get the object's location
const QString& MsnObject::getLocation() const
{
  return location_;
}



// Get the object's size
const int& MsnObject::getSize() const
{
  return size_;
}



// Get the object's type
const QString& MsnObject::getType() const
{
  return type_;
}



// Use an MSN object descriptor from the server to load data
void MsnObject::loadObject( const QString& object )
{
  kdDebug() << "Loading object : " << object << endl;
  creator_  = getAttribute( "Creator",  object );
  location_ = getAttribute( "Location", object );
  size_     = getAttribute( "Size",     object ).toInt();
  type_     = getAttribute( "Type",     object );
}
