/***************************************************************************
                          msnobject.h  -  description
                             -------------------
    begin                : Tue Jul 15 2003
    copyright            : (C) 2003 by Mike K. Bennett
    email                : mike@kmess.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MSNOBJECT_H
#define MSNOBJECT_H

#include <qwidget.h>
#include <qobject.h>

/**This is an MSN object, usually an icon, a picture, or a background.
  *@author Mike K. Bennett
  */

class MsnObject : public QObject
{
  Q_OBJECT

  public: // Public methods
    // The constructor
                     MsnObject();
    // The destructor
                    ~MsnObject();
    // Get the object's creator
    const QString&   getCreator() const;
    // Get the object's location
    const QString&   getLocation() const;
    // Get the object's size
    const int&       getSize() const;
    // Get the object's type
    const QString&   getType() const;
    // Use an MSN object descriptor from the server to load data
    void             loadObject( const QString& object );

  private: // Private methods
    // Parse an attribute from the object string
    QString          getAttribute( const QString& attribute, const QString& object ) const;

  private: // Private attributes
    // The creator of the object
    QString          creator_;
    // The location of the object
    QString          location_;
    // The size of the object
    int              size_;
    // The type of the object
    QString          type_;

};

#endif
