/***************************************************************************
                          ipdialog.h  -  description
                             -------------------
    begin                : Wed Oct 16 2002
    copyright            : (C) 2002 by Mike K. Bennett
    email                : mkb137b@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef IPDIALOG_H
#define IPDIALOG_H

#include <kdialogbase.h>

// Forward declarations
class KRestrictedLine;
class QLabel;

/**This dialog asks the user for his or her true IP address if the obtained one is false.
  *@author Mike K. Bennett
  */

class IpDialog : public KDialogBase
{
  Q_OBJECT

  public:
  	                 IpDialog(QWidget *parent=0, const char *name=0);
  	                ~IpDialog();
    // Get an IP address from the user, or null if a new IP wasn't entered.
    bool             getIpAddress(QString &ipAddress);

  protected slots: // Protected slots
    // Open "www.whatismyip.com"
    void             openIpUrl();
    // The Cancel button was pressed.
    void             slotCancel();
    // The OK button was pressed.
    void             slotOk();

  private: // Private attributes
    KRestrictedLine *ipEdit_;
    QLabel          *ipLabel_;
    // Whether or not OK was pressed.
    bool             ok_;
};

#endif
