/***************************************************************************
                          kderemotedesktop.h  -  description
                             -------------------
    begin                : Sat Mar 22 2003
    copyright            : (C) 2003 by Mike K. Bennett
    email                : mkb137b@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KDEREMOTEDESKTOP_H
#define KDEREMOTEDESKTOP_H

#include <qwidget.h>
#include "application.h"

/**A KMess-to-KMess remote desktop application.
  *@author Mike K. Bennett
  */

class KdeRemoteDesktop : public Application
{
  Q_OBJECT

  public: 
    // The constructor
  	                       KdeRemoteDesktop(const QString& localIp);
    // The destructor
  	                      ~KdeRemoteDesktop();
    // Return the application's GUID
    static QString         getAppId();

  private: // Private methods
    // Step one of a contact-started chat: the contact invites the user
    void                   contactStarted1_ContactInvitesUser(const MimeMessage& message);
    // Step two of a contact-started chat: the user accepts
    void                   contactStarted2_UserAccepts();
    // Step three of a contact-started chat: the contact confirms the accept
    void                   contactStarted3_ContactConfirmsAccept(const MimeMessage& message);
    // Start kde's remote desktop client
    void                   startRemoteClient( bool connectToRemote );
    // Step one of a user-started app: the user invites the contact
    void                   userStarted1_UserInvitesContact();
    // Step two of a user-started app: the contact accepts
    void                   userStarted2_ContactAccepts(const MimeMessage& message);
    // Step three of a user-started app: the user confirms the accept
    void                   userStarted3_UserConfirmsAccept();

  private: // Private attributes
    // The remote IP address
    QString                remoteIp_;
};

#endif
