/***************************************************************************
                          transferprogressdialog.h  -  description
                             -------------------
    begin                : Tue Jun 4 2002
    copyright            : (C) 2002 by Mike K. Bennett
    email                : mkb137b@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TRANSFERPROGRESSDIALOG_H
#define TRANSFERPROGRESSDIALOG_H

#include <qwidget.h>
#include <kdialogbase.h>

// Forward declarations
class KProgress;
class QLabel;

/**A dialog to show the send or receive progress.
  *@author Mike K. Bennett
  */

class TransferProgressDialog : public KDialogBase
{
   Q_OBJECT

  public:
    // The constructor
  	                 TransferProgressDialog(QString description,
                       int totalBytes, QWidget *parent=0,
                       const char *name=0);
    // The destructor
	                  ~TransferProgressDialog();
    // The transfer is finished.
    void             finishTransfer();
    // Update the progress bar.
    void             updateProgress(int noBytes);

  protected slots: // Protected slots
    // The Cancel button was pressed.
    void             slotCancel();
    // The Close button was pressed.
    void             slotClose();
    // The Hide button was pressed.
    void             slotUser1();

  private: // Private attributes
    // The byte count scaling multiplier
    double           multiplier_;
    // The progress bar that gives the % done
    KProgress       *progressBar_;
    // The label showing "x of y bytes transferred"
    QLabel          *progressLabel_;
    // The total number of bytes in the file.
    int              totalBytes_;
    // The string version of the total bytes.
    QString          totalBytesString_;

  signals: // Signals
    // Signal that the transfer should be cancelled
    void             cancelTransfer();
};

#endif
